

#include "strategy.h"
#include <stdlib.h>

#define DRAND()   (((double) rand()) / ( RAND_MAX + 1.0))


class KadlecStrategy : public Strategy { //zmente jmeno tridy 
protected:
	int hist[2];
	int time;
public:
  virtual int operator()() {   
    // dopiste vlastni strategii 
	int ll = hist[(time-1)%2];
	int l = hist[(time)%2];
	if(ll == l) {
		//if(l == COOPERATE)) return DECEIVE;
		return DECEIVE;
		}
    if (DRAND()>0.5) return COOPERATE; else return DECEIVE;  //hist[time%2];
  } 

  virtual void reward(int _reward) {
  	if (_reward == CC || _reward == DC) hist[time%2] = COOPERATE;
    	else hist[time%2] = DECEIVE;
	time++;

		  };

  virtual string getName() { return "kadlr3am Strategie"; }  // pojmenujte si ji  
  KadlecStrategy() {
  	reset();
	}

  virtual void reset() { 
  	time = 0;
	//srand(time(0));
  }
}; 




